import javax.swing.*;                                      
import java.awt.event.*;
import java.awt.image.*;
import java.awt.*;


class DrawingPanel extends JPanel
{
  BufferedImage myImage;
  int width, height, sx, sy;
  
  public void updateImage(){
      sx++; sy++;
      sx%=width; sy%=height;
//      if(myImage!=null) {
      Graphics g = myImage.getGraphics();
//      g.setColor( Color.yellow );
//      g.drawLine(0,0,sx,sy);
//      g.drawLine(sx,0,0,sy);
      
      int rgbArray[] = new int[width*height];
      rgbArray = myImage.getRGB(0,0,width,height,rgbArray,0,width);
      setPixel(myImage, 50, 50, Color.blue);

      int cx, cy;
      for(cx=0;cx<width;cx++)
          for(cy=0;cy<height;cy++) {
     // cx = 50; cy =50;
      int alpha = (rgbArray[cy*width+cx] >> 24) & 0xff;
      int red   = (rgbArray[cy*width+cx] >> 16) & 0xff;
      int green = (rgbArray[cy*width+cx] >>  8) & 0xff;
      int blue  = (rgbArray[cy*width+cx]      ) & 0xff;
      red += 20;
      red %=256;
      rgbArray[cy*width+cx] = (alpha << 24) | (red << 16) | (green << 8) | blue;  
          }
      myImage.setRGB(0,0,width,height,rgbArray,0,width);
      
//      for(int i=0; i < x; i+=2){
         //setPixel(myImage, 50, i, Color.blue);
         //setPixel(myImage, i, 50, Color.red);
         //}
      //}
  }

  public void paintComponent(Graphics g) { 
   super.paintComponent(g);
 //  if(myImage!=null)
   g.drawImage(myImage,0,0,this);
  }

  public void setPixel (Image image, int x, int y, Color color ) {
    Graphics g = image.getGraphics( );
    g.setColor( color );
    g.fillRect( x, y, 1, 1 );
    g.dispose( );
  }
  
  DrawingPanel(int x, int y) {  
    this.width = x;
    this.height = y;
    sx=sy=0;
    myImage =  new BufferedImage(x, y, BufferedImage.TYPE_INT_RGB);
    setMinimumSize(new Dimension(width,height));
    setPreferredSize(new Dimension(width,height));
  } 
} 

public class MyFrame extends JFrame {
    private DrawingPanel p;

    public void Iterate(){
        p.updateImage();
        p.repaint();
    }
    
    public void createComponents() {
        
        p = new DrawingPanel(100,200);
        JButton button = new JButton("Iterate");
        button.setMnemonic(KeyEvent.VK_I);      
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                	Iterate();
            }
        });
        this.getContentPane().setLayout(new GridLayout(1, 2));
        this.getContentPane().add(p);
        this.getContentPane().add(button);
    }
         
    public MyFrame(String arg0) throws HeadlessException {
        super(arg0);
        createComponents();
        pack();
    }
}
